unit F2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Spin, IniFiles;

type
  TFormSetup = class(TForm)
    BtnClose: TButton;
    EdChan: TSpinEdit;
    Label1: TLabel;
    SG2: TStringGrid;
    EdPause: TSpinEdit;
    Label2: TLabel;
    procedure BtnCloseClick(Sender: TObject);
    procedure EdChanChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SG2SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EdPauseChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSetup: TFormSetup;
  NumChan:   DWORD = 1;
  AdrChan:   ARRAY [0..999,0..2] OF BYTE;
  FI:        TIniFile;
  Pause:     INTEGER = 4;

implementation

USES F1;

{$R *.DFM}

procedure TFormSetup.BtnCloseClick(Sender: TObject);
begin
 FormSetup.Close;
end;

procedure TFormSetup.EdChanChange(Sender: TObject);
VAR I,K:INTEGER;
begin
 VAL(EdChan.Text,I,K);
 IF (K<>0)OR(I>EdChan.MaxValue)OR(I<EdChan.MinValue) THEN EdChan.Value:=NumChan ELSE NumChan:=I;
 SG2.RowCount:=NumChan+1;
 Form1.SG.RowCount:=NumChan+1;
 FOR I:=1 TO NumChan DO
  BEGIN
   SG2.Cells[0,I]:='    '+IntToStr(I);
   SG2.Cells[1,I]:='    '+IntToStr(AdrChan[I-1,0]);
   SG2.Cells[2,I]:='    '+IntToStr(AdrChan[I-1,1]);
   SG2.Cells[3,I]:='    '+IntToStr(AdrChan[I-1,2]);
   Form1.SG.Cells[0,I]:='   '+IntToStr(I);
  END;
end;

procedure TFormSetup.FormCreate(Sender: TObject);
VAR I,L:INTEGER;
begin
 SG2.Cells[0,0]:=' ';
 SG2.Cells[1,0]:=' COM';
 SG2.Cells[2,0]:='';
 SG2.Cells[3,0]:=' ';
 FOR I:=0 TO 998 DO
  BEGIN
   AdrChan[I,0]:=2;
   AdrChan[I,1]:=1;
   AdrChan[I,2]:=0;
  END;
 FI:=NIL;
 TRY
 FI:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 I:=FI.ReadInteger('PARAM','Speed',5); IF (I<0)OR(I>6) THEN I:=5;
 Form1.BoxSpeed.ItemIndex:=I;
 NumChan:=FI.ReadInteger('PARAM','Num',1);
 Pause:=FI.ReadInteger('PARAM','Pause',4);
 FOR I:=0 TO (NumChan-1) DO
  BEGIN
   L:=FI.ReadInteger('PARAM','COMPribor'+IntToStr(I+1),2);   IF (L<1)OR(L>12) THEN L:=2;
   AdrChan[I,0]:=L;
   AdrChan[I,1]:=FI.ReadInteger('PARAM','Pribor'+IntToStr(I+1),1);
   AdrChan[I,2]:=FI.ReadInteger('PARAM','Channel'+IntToStr(I+1),0);
  END;
 FI.Free;
 EXCEPT
  IF FI<>NIL THEN FI.Free;
  NumChan:=1;
  AdrChan[0,0]:=2;
  AdrChan[0,1]:=1;
  AdrChan[0,2]:=0;
  Pause:=4;
 END;

 EdPause.Value:=Pause;
 EdChan.Value:=NumChan;
 EdChanChange(Sender);
 Form1.SG.Visible:=TRUE;
 Form1.BoxSpeedChange(Sender);
end;

procedure TFormSetup.SG2SetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
VAR I,K:INTEGER;
begin
 IF  SG2.Cells[ACol,ARow]<>'' THEN
 BEGIN
  VAL(SG2.Cells[ACol,ARow],I,K);
  IF ACol=1 THEN
   BEGIN
    IF (K<>0)OR(I>12)OR(I<1) THEN
     SG2.Cells[ACol,ARow]:='    '+IntToStr(AdrChan[ARow-1,ACol-1]) ELSE
     AdrChan[ARow-1,ACol-1]:=I;
   END ELSE
   BEGIN
    IF (K<>0)OR(I>255)OR(I<0) THEN
     SG2.Cells[ACol,ARow]:='    '+IntToStr(AdrChan[ARow-1,ACol-1]) ELSE
     AdrChan[ARow-1,ACol-1]:=I;
   END;
 END;
end;

procedure TFormSetup.FormClose(Sender: TObject; var Action: TCloseAction);
VAR I:INTEGER;
begin
 Hide;
 FI:=NIL;
 TRY
 FI:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 FI.WriteInteger('PARAM','Num',NumChan);
 FI.WriteInteger('PARAM','Pause',Pause);
 FOR I:=0 TO (NumChan-1) DO
  BEGIN
   FI.WriteInteger('PARAM','COMPribor'+IntToStr(I+1),AdrChan[I,0]);
   FI.WriteInteger('PARAM','Pribor'+IntToStr(I+1),AdrChan[I,1]);
   FI.WriteInteger('PARAM','Channel'+IntToStr(I+1),AdrChan[I,2]);
  END;
 FI.Free;
 EXCEPT
  IF FI<>NIL THEN FI.Free;
 END;
end;

procedure TFormSetup.EdPauseChange(Sender: TObject);
VAR I,K:INTEGER;
begin
 VAL(EdPause.Text,I,K);
 IF (K<>0)OR(I>EdPause.MaxValue)OR(I<EdPause.MinValue) THEN EdPause.Value:=Pause ELSE Pause:=I;
end;

end.
